(*----------------------------------------------------------------------------*
 *  Direct3D Shader Disassembler                                              *
 *                                                                            *
 *  "ShaderLexer" unit contains shader disassembler with embedded simple way  *
 *  to export disassembled data as text output. But actually it was designed  *
 *  to be used for shader data analis. So other usage scenarios possible      *
 *                                                                            *
 *  Copyright (c) 2005 by Alexey Barkovoy                                     *
 *  E-Mail: clootie@clootie.ru                                                *
 *                                                                            *
 *  Modified: 05-May-2005                                                     *
 *                                                                            *
 *  Latest version can be downloaded from:                                    *
 *     http://www.clootie.ru                                                  *
 *----------------------------------------------------------------------------*)
 
program D3DShaderDAsm;

{$APPTYPE CONSOLE}

uses
  SysUtils, 
  ShaderLexer in 'ShaderLexer.pas';

var
  SL: TD3DShaderLexer;
  Correct: Boolean;
  Errors: String;
begin
  SL:= TD3DShaderLexer.Create('TestShader.vsa');
  // SL.ExtendedPrecisionContants:= True;
  SL.SaveToFile('TestShader.opt');

  if not SL.VerifyDisassembly(Correct, Errors) then
  begin
    WriteLn('Verify failed: No D3DX9 library found on computer - requires one of these: '+
            'd3dx9_26.dll, d3dx9_25.dll, d3dx9_24.dll, D3DX92ab.dll, D3DX9ab.dll, D3DX9d.dll');
  end else
  begin
    if Correct then
      Writeln('Disassembly succeded!!!')
    else
      Writeln('Errors found in dissassembled shader!'#10#13, Errors);
  end;
  {Readln;}

  SL.Free;
end.

